<?php

namespace Drupal\rc_group\Plugin\Action;

use Drupal\Core\Access\AccessResult;
use Drupal\group\Entity\Group;
use Drupal\views_bulk_operations\Action\ViewsBulkOperationsActionBase;
use Drupal\Core\Session\AccountInterface;

/**
 * TODO: under active development, don't use for production.
 *
 * @Action(
 *   id = "rc_create_group",
 *   label = @Translation("Create chat group for the selected groups"),
 *   type = "group",
 *   confirm = TRUE,
 *   requirements = {
 *     "_permission" = "Manage Rocket Chat settings",
 *   },
 * )
 */
class RcCreateGroup extends ViewsBulkOperationsActionBase {

  /**
   * {@inheritdoc}
   */
  public function execute($entity = NULL) {

    // Get the group types configurations.
    $config = \Drupal::config('rc_group.settings');
    $bundlesConfig = $config->get('group_chat_types.types');
    $bundles = [];
    foreach ($bundlesConfig as $bundle => $value) {
      if ($value) {
        $bundles[] = $bundle;
      }
    }
    $groupType = $entity->bundle();
    if ($entity->getEntityTypeId() == 'group' && in_array($groupType, $bundles)) {
      $rcGroup = \Drupal::service('rc_group.group');
      $createGroup = $rcGroup->createGroup($entity, TRUE);

      if ($createGroup) {

        // Add group owner as chat group owner.
        $groupOwner = $entity->getOwner();
        $rcGroup->groupAddOwnerByAdmin($groupOwner, $entity);

        // Add members to room.
        $members = $entity->getMembers();
        foreach ($members as $member) {

          $user = $member->getUser();
          if ($user->field_rcid->value) {
            $rcGroup->groupInviteUser($groupOwner, $user, $entity);
          }

          // Add moderator role
          $rcModeratorRoles = $config->get('groups_moderator_roles');

          if (array_key_exists($groupType, $rcModeratorRoles)) {
            $rcGroupModRoles = $rcModeratorRoles[$groupType];
            foreach ($rcGroupModRoles as $role => $value) {
              if ($value) {

              }
            }
            $userGroupRules  = $member->getRoles();

          }

        }

        // Update account roles according to user group roles.

        return $this->t(' chat channel is created for group ' . $entity->label());
      }
    }

  }

  /**
   * {@inheritdoc}
   */
  public function access($object, AccountInterface $account = NULL, $return_as_object = FALSE) {

    if ($object instanceof Group) {
      $access = AccessResult::allowed();
    }
    else {
      $access = AccessResult::forbidden();
    }

    return $return_as_object ? $access : $access->isAllowed();
  }

}
