<?php

namespace Drupal\rc\Plugin\Action;

use Drupal\views_bulk_operations\Action\ViewsBulkOperationsActionBase;
use Drupal\Core\Session\AccountInterface;

/**
 * Some description.
 *
 * @Action(
 *   id = "rc_update_user",
 *   label = @Translation("Update chat accounts for the selected users"),
 *   type = "user",
 *   confirm = TRUE,
 *   requirements = {
 *     "_permission" = "Manage Rocket Chat settings",
 *   },
 * )
 */
class RcUpdateUser extends ViewsBulkOperationsActionBase {

  /**
   * {@inheritdoc}
   */
  public function execute($entity = NULL) {
    if ($entity->getEntityTypeId() == 'user') {
      $rcUser = \Drupal::service('rc.user');
      $updateUser = $rcUser->updateUser($entity, TRUE);
      if ($updateUser) {
        return $this->t($updateUser->getUsername() . ' chat account is updated for user ' . $entity->getDisplayName());
      }
    }

  }

  /**
   * {@inheritdoc}
   */
  public function access($object, AccountInterface $account = NULL, $return_as_object = FALSE): bool {
    if ($object->getEntityType() === 'user') {
      $access = $object->access('update', $account, TRUE)
        ->andIf($object->status->access('edit', $account, TRUE));
      return $return_as_object ? $access : $access->isAllowed();
    }

    return TRUE;
  }

}
